# -*- coding: utf-8 -*-
"""
How to use?
Example: 
INPUT:    de_landmass.gpx
COMMAND:  python simplify_landmass.py de_landmass.gpx
OUTPUT:   de_landmass.txt
"""
try:
    import gpxpy
except:
    print "To perform simplification the package gpxpy is required. You may install it via 'pip install gpxpy'."
    exit(0)
import sys

if len(sys.argv) > 1:
    infile = sys.argv[1]
    
    print 'Open: ', infile
    gpx_file = open(infile, 'r')
    gpx_data = gpxpy.parse(gpx_file)
    distance = int(sys.argv[2]) if len(sys.argv) == 3 else 300
    
    print 'Simplifying with max_distance = ', distance
    gpx_data.simplify(max_distance = distance)
    
    outfile_name = infile.replace('gpx','txt')
    outfile = open(outfile_name,'w')
    for track in gpx_data.tracks:
            for segment in track.segments:
                lat = []
                lon = []
                for point in segment.points:
                    lat.append(point.latitude)
                    lon.append(point.longitude)
                lon = ','.join([str(l) for l in lon])
                lat = ','.join([str(l) for l in lat])
                outfile.write( lon + '|' + lat + '\n')
    outfile.close()
    gpx_file.close()
    print 'Saved simplified landmass data: %s' %(outfile_name)

